part of modular_navigation;

class NoPageParametersRoute<TModularPage extends NoParametersModularPage>
    extends ModularRoute<NoPageParameters, TModularPage> {
  NoPageParametersRoute(
      {required BaseModule module,
      required String route,
      required TModularPage Function() createPage,
      FutureOr<bool> Function(
              ModularHistory route, ModularRouterDelegate delegate)?
          guard})
      : super(
          module: module,
          route: route,
          createPage: (params) => createPage(),
          guard: guard,
        );

  ModularLink<PageParameters> createLink() {
    return super._createLink(NoPageParameters());
  }

  TModularPage create() {
    return super._create(NoPageParameters()) as TModularPage;
  }

  void navigate({
    required BuildContext context,
    bool clearHistory = false,
    bool removeCurrent = false,
  }) {
    super._navigate(
      context,
      NoPageParameters(),
      clearHistory: clearHistory,
      removeCurrent: removeCurrent,
    );
  }
}
