part of modular_navigation;

class RequiredPageParametersRoute<TPageParameters extends PageParameters,
        TModularPage extends ModularPage<TPageParameters>>
    extends ModularRoute<TPageParameters, TModularPage> {
  RequiredPageParametersRoute(
      {required BaseModule module,
      required String route,
      required TModularPage Function(Map<String, String?> params) createPage,
      FutureOr<bool> Function(
              ModularHistory route, ModularRouterDelegate delegate)?
          guard})
      : super(
          module: module,
          route: route,
          createPage: createPage,
          guard: guard,
        );

  void navigate({
    required BuildContext context,
    required TPageParameters parameters,
    bool clearHistory = false,
    bool removeCurrent = false,
  }) {
    super._navigate(
      context,
      parameters,
      clearHistory: clearHistory,
      removeCurrent: removeCurrent,
    );
  }

  ModularLink<PageParameters> createLink(TPageParameters parameters) {
    return super._createLink(parameters);
  }

  TModularPage create(TPageParameters parameters) {
    return super._create(parameters) as TModularPage;
  }
}
